/*
 * Component Name: WAS.isc.isclite.cp
 * 
 * Licensed Materials - Property of IBM
 * 5724-I63, 5724-H88, 5655-N02, 5733-W70 
 * Copyright IBM Corp. 2006, 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 * 
 */
 
function iscIsInteger(s){

    if(!s || s.length<=0){
      return false;
    }
    
    var i;
    for (i = 0; i < s.length; i++){   
        var c = s.charAt(i);
        if (((c < "0") || (c > "9"))) {
          return false;
        }
    }
    return true;
}

function iscValidateGoToPage(inputId,numOfPages,errMsg){
  var val = inputId.value;
  if(iscIsInteger(val)){
    if(val >0 && val <=numOfPages ){
      return true;
    }
  }
  alert(errMsg+" "+numOfPages);
  return false;
}
function iscPagingGoToPage(inputId,numOfPages,errMsg){

    isValid = iscValidateGoToPage(inputId,numOfPages,errMsg);
    if(isValid){
        try{
            if(fpEnabled){
                fpResetSubmitForm();
            }
        }catch(err){
            // no fp enabled
        }
    }
    return isValid;
}

function iscCountSelected(tmpForm,checkboxName){
	var count = 0;
    var theForm = document.forms[tmpForm];
    if(!theForm){
      return;
    }				
    var elements = theForm.elements;
    for(var i =0; i < elements.length;i++){
		if (elements[i].type == "checkbox") {
            if(checkboxName){
                if(elements[i].name!=checkboxName){
                    continue;
                }
            }
            if (elements[i].checked){
				count++;
			}			            
		}
    }		    
	return count;
}

function iscDisplaySelected(tmpForm,spanId,checkboxName){

	var count = iscCountSelected(tmpForm,checkboxName);
    
	var spn = document.getElementById(spanId+".T");
	if (spn !== null){
		spn.innerHTML = count;
	}
	spn = document.getElementById(spanId+".B");
	if (spn !== null){
		spn.innerHTML = count;
	}	
}
function iscDeselectAll(tmpForm,spanId,checkboxName) {

    var theForm = document.forms[tmpForm];
    if(!theForm){
      return;
    }
    
    var elements = theForm.elements;
    for(var i =0; i < elements.length;i++){
       if (elements[i].type == "checkbox") {
            if(checkboxName){
                if(elements[i].name!=checkboxName){
                    continue;
                }
            }
            elements[i].checked = false;
            iscFindParentRow(elements[i],"table-row");
      }
    }
    
    iscDisplaySelected(tmpForm,spanId,checkboxName);
}

function iscSelectAll(tmpForm,spanId,checkboxName) {
    var theForm = document.forms[tmpForm];
    if(!theForm){
      return;
    }
    var count = 0;
    var elements = theForm.elements;
    for(var i =0; i < elements.length;i++){
       if (elements[i].type == "checkbox") {
       
              if(checkboxName){
                if(elements[i].name!=checkboxName){
                    continue;
                }
              }
              
              elements[i].checked = true;
              iscFindParentRow(elements[i],"table-row-selected");
              count++;
      }
    }
    iscDisplaySelected(tmpForm,spanId,checkboxName);
}

function iscFindParentRow(el,st) {
    par = el.parentNode;
    if (par.tagName == "TR") {
        par.className = st;
    } else {
        iscFindParentRow(par,st);
    }
}

function iscHighLightSelectedRows(tmpForm,spanId,checkboxName){

	var theForm = document.forms[tmpForm];
    if(!theForm){
      return;
    }
    var elements = theForm.elements;
    for(var i =0; i < elements.length;i++){
       if (elements[i].type == "checkbox") {
       
              if(checkboxName){
                if(elements[i].name!=checkboxName){
                    continue;
                }
              }
              
              if(elements[i].checked){
                    iscFindParentRow(elements[i],"table-row-selected");
              }
              
      }
    }
   iscDisplaySelected(tmpForm,spanId,checkboxName);
}

function iscHighLightParentRow(el,tmpForm,spanId){

      if(el.checked){
        iscFindParentRow(el,"table-row-selected");
      }else{
        iscFindParentRow(el,"table-row");
      }      
      iscDisplaySelected(tmpForm,spanId,el.name);
}
function iscShowHideSection(objectId) {
    if (document.getElementById(objectId) !== null) {
        if (document.getElementById(objectId).style.display == "none") {
            document.getElementById(objectId).style.display = "inline";
            if (document.getElementById(objectId+"Img")) {
                document.getElementById(objectId+"Img").src = "/ibm/console/images/arrow_expanded.gif";
            }
            if(document.getElementById(objectId+"Count")){
                document.getElementById(objectId+"Count").style.display = "none";
            }
            
        } else {
            document.getElementById(objectId).style.display = "none";
            if (document.getElementById(objectId+"Img")) {
                document.getElementById(objectId+"Img").src = "/ibm/console/images/arrow_collapsed.gif";
            }
            if(document.getElementById(objectId+"Count")){
                document.getElementById(objectId+"Count").style.display = "inline";
            }
        }
    }
}
function iscGetFormName(element){

        theElement = element;
        while(true){
        
           if(theElement.tagName=="FORM"){
                return theElement.name;
           }
           
           if(theElement.parentNode){
                theElement=theElement.parentNode;
            }else{
                return null;
            }
            
        }
        
}
function iscShowWatingDiv(divId,element,e){
	divObj = document.getElementById? document.getElementById(divId): null;
	if(divObj!==null){
	

			var posx = 0;
			var posy = 0;
			if (!e) { 
				e = window.event;
			}
			if (e.pageX || e.pageY) 	{
				posx = e.pageX;
				posy = e.pageY;
			}
			else if (e.clientX || e.clientY) 	{
				posx = e.clientX + document.body.scrollLeft
					+ document.documentElement.scrollLeft;
				posy = e.clientY + document.body.scrollTop
					+ document.documentElement.scrollTop;
			}
			if(posx===0 && posy===0 ){
				// the button was clicked using keabord
				elementPos = iscFindPos(element);
				posx = elementPos[0];
				posy = elementPos[1];
				
			}
			
		
		
        divObj.style.left = posx+"px"; 
		divObj.style.top = posy+"px";
		setTimeout("document.getElementById('" + divId + "').style.visibility = 'visible'", 2000);
	}
}
function iscFindPos(obj) {

    curleft = curtop = 0;
    if (obj.offsetParent) {
        curleft = obj.offsetLeft;
        curtop = obj.offsetTop;
        while (obj = obj.offsetParent) {
            curleft += obj.offsetLeft;
            curtop += obj.offsetTop;
        }
    }
    return [curleft,curtop];   
}

var iscSubmitCount=0;
function iscCheckSubmit(){
    if (iscSubmitCount == 0){
     iscSubmitCount++;          
     return true;
    } else {
     return false;
    }
   }
function iscDisableElements(formName,elementsString,toDisable,checkboxName){

    if(!document.forms[formName]){
        return;
    }
    if(!toDisable){
        
        selected = iscCountSelected(formName,checkboxName); 
        if(selected<=0){
            return;
        }
    }
    var elementArray = elementsString.split(",");
    for(i=0;i<document.forms[formName].elements.length;i++){
        for (j in elementArray ){
            if(elementArray[j]==document.forms[formName].elements[i].name){
                document.forms[formName].elements[i].disabled=toDisable;
                break;
            }
        }
    }
}
function iscAddDisableHandlers(formName,elementsString,spanId,checkboxName){
    if(!document.forms[formName]){
        return;
    }
    theLinks = document.forms[formName].getElementsByTagName("a");
    for (i in theLinks ) {
        if('selectAllButton'==theLinks[i].name){
            theLinks[i].href='javascript:iscDisableElements("'+formName+'","'+elementsString+'",'+false+',"'+checkboxName+'");';
            continue;
        }
        if('delectAllButton'==theLinks[i].name){
            theLinks[i].href='javascript:iscDisableElements("'+formName+'","'+elementsString+'",'+true+',"'+checkboxName+'")';
            continue;
        }
    }
}
function iscUpdateField(formName,fieldName,fieldValue){

    var theForm = document.forms[formName];
    if(!theForm){
      return;
    }
    
    var elements = theForm.elements;
    if(!elements){
        return;
    }
    
    var element = elements[fieldName];
    if(!element){
        return;
    }
 
    if( (!element.type) || (element.type=='select-one') || (element.type=='radio') ){
    
        if(!element.length){
            element.checked=true;
            return;
        }
        
        for(var i=0;i<element.length;i++){
            if(element[i].value){
                if(element[i].value==fieldValue){
                    element[i].checked=true;
                    break;
                }
            }
        }
        
    }else{
        if(element.value){
            element.value=fieldValue;
        }
    }
   
}
function iscSetDefaultFocus(formName,elementArray){
	var theForm = document.forms[formName];
    if(!theForm){
      return;
    }
    
    var elements = theForm.elements;
    if(!elements){
        return;
    }
	
	for(i=0;i<elementArray.length;i++){
		element = elements[elementArray[i]];
		if(element.type){
            if(element.name && element.name==elementArray[i]){
               if(!element.disabled){
                    try{
				        element.focus();
                    }catch(err){
                        // trying to set the focus on hidden element
                    }
				    break;
			    }
            }
			
		}
	}
	
}
function iscEnterPressHandler(formName,buttonName,e){
    
    var key =null;
    var keyDownEvent=null;
    
    if(window.event) { // IE 
        key = e.keyCode;
        keyDownEvent = window.event;
    }else if(e.which){ // Netscape/Firefox/Opera
         key = e.which;
         keyDownEvent = e;
    }
    
    if (key == 13){ // process only the Enter key
       
        // cancel the default submit
        if (window.event) {// IE 
			keyDownEvent.cancelBubble = true;
            keyDownEvent.cancel = true;
			keyDownEvent.returnValue = false;
		} else {// Netscape/Firefox/Opera
			keyDownEvent.preventDefault();
			keyDownEvent.stopPropagation();
		}
        
        
        var theForm = document.forms[formName];
        if(!theForm){
            return;
        }
        
        var elements = theForm.getElementsByTagName("input");
        var btn =null;
        for(i=0;i<elements.length;i++){
            if(elements[i].name==buttonName){
                btn = elements[i]; 
                break;
            }
        }
        
        // submit the form by programmatically clicking the specified button
        if(btn){
            btn.click(); 
        }
    }
   
}