/*
 * Component Name: WAS.isc.isclite.cp
 * 
 * Licensed Materials - Property of IBM
 * 5724-I63, 5724-H88, 5655-N02, 5733-W70 
 * Copyright IBM Corp. 2006, 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 * 
 */
 
//Form persistence global variables
var fpEnabled                     = true;

var fpSubmitFormName              = '';                                               //holds the sibmiting form name
var fpFocusedElementName          = '';                                               //holds the name last focused element 
var fpFocusedElementFormName      = '';
var fpCurrentPageId               = '';                                               //holds the current page id
var fpXmlHttpRequest              = false;                                            //the Ajax request used by Form persistence mechanism
var fpUrl                         = '/ibm/console/fpa.do';                            // Form Persistence action url
var fpHttpMethod                  = 'POST';                                           // Ajax request type
var fpSkipPersistenceOnUnload     = false;                                            // Whether to skip the persistence on unload - when the user close the current page from the task bar

var fpSerializableElementTypes 	  = ["text","checkbox","hidden","radio","textarea","select-one","select-multiple"]; 

var fpInFieldDelimiter            = "#vd#";                                           // name value delimiter
var fpFieldDelimiter              = "#ed#";                                           // field delimiter
var fpFormDelimiter               = "#fd#";                                           // form delimiter
var fpCursorDelimiter             = "#cd#";                                           // cursor delimiter 
var fpSubmitFormDelimiter         = "#sd#";

var fpInFieldDelimiterEscaped     = "#\\vd#";
var fpFieldDelimiterEscaped       = "#\\ed#"; 
var fpFormDelimiterEscaped        = "#\\fd#";   
var fpCursorDelimiterEscaped      = "#\\cd#"; 
var fpSubmitFormDelimiterEscaped  = "#\\sd#";

var fpPortletIdPrefix			  = "iscPortlet_";
var fpPortletIdDelimiter		  = ";";

//End of Form persistence global variables



// escape fp delimiters
function fpEscape(str){

    var theString = str;
    theString= fpReplaceAllSmart(theString,"\\","\\\\");
    
    theString=fpReplaceAll(theString,fpInFieldDelimiter,fpInFieldDelimiterEscaped);
    theString=fpReplaceAll(theString,fpFieldDelimiter,fpFieldDelimiterEscaped);
    theString=fpReplaceAll(theString,fpFormDelimiter,fpFormDelimiterEscaped);
    theString=fpReplaceAll(theString,fpCursorDelimiter,fpCursorDelimiterEscaped);
    theString=fpReplaceAll(theString,fpSubmitFormDelimiter,fpSubmitFormDelimiterEscaped);
    
    return theString;
  
}

// unescape fp delimiters
function fpUnescape(str){

    var theString = str;
    
    theString=fpReplaceAll(theString,fpInFieldDelimiterEscaped,fpInFieldDelimiter);
    theString=fpReplaceAll(theString,fpFieldDelimiterEscaped,fpFieldDelimiter);
    theString=fpReplaceAll(theString,fpFormDelimiterEscaped,fpFormDelimiter);
    theString=fpReplaceAll(theString,fpCursorDelimiterEscaped,fpCursorDelimiter);
    //theString=fpReplaceAll(theString,fpSubmitFormDelimiterEscaped,fpSubmitFormDelimiter);//- the response does not contains the submitting form name
    
    theString= fpReplaceAllSmart(theString,"\\\\","\\");
    return theString;
     
}

// escape +
function fpEncodeText(str){
    var encodedString = escape(str);
	encodedString = fpReplaceAll(encodedString,"+", "%2B");
	return encodedString;		
}

// replace all using str.replace
function fpReplaceAll(strInput,strTarget,strSubString){
        var strText = strInput;
        var intIndexOfMatch = strText.indexOf( strTarget );

        while (intIndexOfMatch != -1){

            strText = strText.replace( strTarget, strSubString );
            intIndexOfMatch = strText.indexOf( strTarget ); 
        }
        
        return strText;
}

// replace all without using str.replace
function fpReplaceAllSmart(strInput,strTarget,strSubString){
        var strText = strInput;
        var intIndexOfMatch = strText.indexOf( strTarget );
        if(intIndexOfMatch==-1){
            return strText;
        }
        
        var strTextReplaced = "";
        var start=0;
        while(intIndexOfMatch!=-1){
            strTextReplaced+=strText.substring(start,intIndexOfMatch);
            strTextReplaced+=strSubString;
            start=intIndexOfMatch+strTarget.length;
            intIndexOfMatch = strText.indexOf(strTarget,start);
        }
        if(start<strText.length){
            strTextReplaced+=strText.substring(start,strText.length);
        }
       
        return strTextReplaced;
}

// End of Form Persistence util functions



// Form Persistence functions 

// Add the Form Persistence event handlers
function fpAddHandlers(pageId){
		
		    fpCurrentPageId = pageId;
		    
        	window.onunload = fpSave;   // persist data on unload
    		window.onload   = fpFetch;  // fetch data on load
    		
    		//add event handlers for finding out the submiting form name and last focused element
        if (window.opera || (!document.all) ){//for FireFox and Opera
          
      		window.captureEvents(Event.CLICK);
      		window.onclick = fpSaveSubmitForm;
      		
      		window.captureEvents(Event.KEYPRESS); 
          	window.onkeyup = fpSaveSubmitFormOnKeyUp;
          
            // do not add fpHandlers if these frames do not exists
            if(parent && parent.frames){
                if(parent.frames.header){
                   parent.frames.header.captureEvents(Event.CLICK);
                   parent.frames.header.onclick=fpResetSubmitForm;
                  
                   parent.frames.header.captureEvents(Event.KEYPRESS); 
                   parent.frames.header.onkeyup = fpResetSubmitForm;
                } 
                
                if(parent.frames.navigation){
                   parent.frames.navigation.captureEvents(Event.CLICK);
                   parent.frames.navigation.onclick=fpResetSubmitForm;
                  
                   parent.frames.navigation.captureEvents(Event.KEYPRESS); 
                   parent.frames.navigation.onkeyup = fpResetSubmitForm;
                }
            }
    
      	 
      	} else {//for IE
      	
      	  window.document.onfocusin=fpSaveSubmitForm;
      	  window.document.onfocusout=fpResetSubmitForm;
      	  
      	}	
      	
}// end of fpAddHandlers(pageId)


// Save submitting form name
function fpSaveSubmitForm(evt){
	
      var target=null;
      if (!evt){
            evt = window.event;
      }
      
      if (evt.target) {//for FireFox
            target = evt.target;
      }else if (evt.srcElement) {//for IE
            target = evt.srcElement;
      }

      if(target.form){
        fpFocusedElementName      = target.name;
        fpSubmitFormName          = fpConstructFormName(target.form);
        fpFocusedElementFormName  = fpConstructFormName(target.form);
        
      }else{
          fpFocusedElementName      = '';
          fpSubmitFormName          = '';
          fpFocusedElementFormName  = '';
      }  
      
}// end of fpSaveSubmitForm(evt)

//save submitting form name 
function fpSaveSubmitFormOnKeyUp(evt){
	
  	  if(evt.which){ //FireFox 
        if(evt.which==9){//TAB 
          fpSaveSubmitForm(evt);
        } 
      }
      
} // end of fpSaveSubmitFormOnKeyUp(evt)

//reset submitting form name 
function fpResetSubmitForm(){

       fpSubmitFormName="";
       
}// end of fpResetSubmitForm()

//persist the form data using Axax request
function fpSave() {
    if(fpPreSave()){
        if(!fpSkipPersistenceOnUnload){
        
           var fpPageAsString= "";
           
           if(fpPreSerialize()){
                fpPageAsString = fpSerializePage();
           }
           fpPostSerialize();
           
           fpMakeAjaxCall("putCache",fpAjaxPutCacheResponseHandler,fpPageAsString);
              
        }
    }
	
}// end of fpSave()

//fetch the current page persisted data using Axax request
function fpFetch() {

      if(fpPreFetch()){
	    fpMakeAjaxCall("getCache",fpAjaxGetCacheResponseHandler,'','');
      }
	
}

// Form Persistence Ajax specific functions

// create XMLHttpRequest
function fpCreateXMLHttpRequest() {
	   
      try {
        fpXmlHttpRequest = new XMLHttpRequest();
      } catch (trymicrosoft) {
        try {
          fpXmlHttpRequest = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (othermicrosoft) {
          try {
            fpXmlHttpRequest = new ActiveXObject("Microsoft.XMLHTTP");
          } catch (failed) {
            fpXmlHttpRequest = false;
          }
        }
      }
      
}// end of fpCreateXMLHttpRequest()
  
// make Form Persistence Ajax request
function fpMakeAjaxCall(fpRequestType,fpAjaxResponseHandler,fpTextToPersist){
  
    fpCreateXMLHttpRequest();
    if(!fpXmlHttpRequest){
       alert("Cannot create XMLHttp Request");
      return;
    }
    
    var fpHttpParameters='RT='+fpRequestType+'&POID='+fpCurrentPageId+'&ISCPersistText='+escape(fpTextToPersist);//escape(escape(fpTextToPersist));

    fpXmlHttpRequest.onreadystatechange=fpAjaxResponseHandler;
    fpXmlHttpRequest.open(fpHttpMethod, fpUrl, true);
    fpXmlHttpRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    fpXmlHttpRequest.setRequestHeader("Content-length", fpHttpParameters.length);
    fpXmlHttpRequest.setRequestHeader("Connection", "close");
    fpXmlHttpRequest.send(fpHttpParameters);
  
}// end of fpMakeAjaxCall(fpRequestType,fpAjaxResponseHandler,fpTextTpPersist)

// hadle get cache Ajax response
function fpAjaxGetCacheResponseHandler(){
 	try{
        if (fpXmlHttpRequest.readyState == 4){
            if (fpXmlHttpRequest.status == 200){
            
                var persistedText = fpXmlHttpRequest.responseText;
                persistedText = unescape(persistedText);
                persistedText = persistedText.replace(/^\s*|\s*$/g,"");
                
                if(fpPreDeserialize()){
                    fpDeSerializePage(persistedText);
                    fpPostDeserialize();
                }
                
                fpPostFetch();
                
                
            }else if (fpXmlHttpRequest.status == 404){
                 alert("Form Persistence request URL does not exist : "+fpUrl);
            }else{
                 alert("Form Persistence error: status code is " + fpXmlHttpRequest.status);
            }
        }   
    }catch(err){
        // do nothing fpXmlHttpRequest is still not created
    }
}// end of fpAjaxGetCacheResponseHandler()


// hadle put cache Ajax response
function fpAjaxPutCacheResponseHandler(){
    
    //do nothing on send data to server
    // otherwise get the error : fpXmlHttpRequest is not defiend
    
}// end of fpAjaxPutCacheResponseHandler()

// End of Form Persistence Ajax specific functions


// check if an element ican be serialized
function fpIsElementSerializable(elementType){

   for(var i=0;i< fpSerializableElementTypes.length;i++){
  
  	      if(fpSerializableElementTypes[i]==elementType){
  	         return true;
          }
          
  }
  return false;
}// end of fpIsElementSerializable

// serialize the current page
function fpSerializePage(){
    								
    var pageAsString      =   '';
    var formAsString      =   '';
    var elementAsString   =   '';
    
  	
  	// iterate trhough all forms of the document
  	for( var f=0 ; f < document.forms.length ; f++ ){
  	   
  	     formAsString  = '';
  	     
  	     // check if the current form is the submiting form 
         if(fpConstructFormName(document.forms[f])==fpSubmitFormName){
  	     //if(document.forms[f].name==fpSubmitFormName){
  	       continue;//skip the submittig form 
         }
         
		 formElement = document.forms[f];
         
         formAsString = fpConstructFormName(formElement);
         formAsString  +=  fpFieldDelimiter;
		 
  	     //iterate through all fileds of the form
  	     for(  var e=0 ; e < document.forms[f].elements.length ; e++ ){
  	       
  	         elementAsString   =   '';
              
             elementType = document.forms[f].elements[e].type;
             
  	         // check if the field chan be serialized
  	         if(!fpIsElementSerializable(elementType)){
  	           continue;
             }
             
             //serialize the current element
             
             elementAsString  +=  fpEncodeText(fpEscape(document.forms[f].elements[e].name));
             elementAsString  +=  fpInFieldDelimiter;
              
             if( (elementType=="checkbox") || (elementType=="radio")){   
                  
                  // for checkbox or radio buttons save alse the value in case have
                  // a couple of checkboxes with the same name
                    elementId = document.forms[f].elements[e].id ? document.forms[f].elements[e].id : "";
                    elementAsString  +=   fpEncodeText(fpEscape(elementId));
                    elementAsString  +=  fpInFieldDelimiter;

                  elementAsString  +=  fpEncodeText(fpEscape(document.forms[f].elements[e].value));
                  elementAsString  +=  fpInFieldDelimiter;
                  elementAsString  +=  document.forms[f].elements[e].checked;
                  
             } else if ( (elementType=="select-one") ){
             
                 elementAsString  +=  document.forms[f].elements[e].selectedIndex;
                 
             } else if ( (elementType=="select-multiple") ){
             
                   for (var o = 0; o < document.forms[f].elements[e].options.length; o++) {
                   
    	      		     if ( document.forms[f].elements[e].options[o].selected ) {
    	      		     
    	      		        elementAsString+=o;
    	      		        elementAsString+=fpInFieldDelimiter;
    	      		        
    	      	      	}
    	      	      	
    	           	 }	
                   elementAsString = elementAsString.substring(0,elementAsString.length -fpInFieldDelimiter.length ); 
             } else{ 
                // for text, textarea and hidden fields
                elementAsString  += fpEncodeText(fpEscape(document.forms[f].elements[e].value));
             }
  	       
  	         // append element string to the form serialization
             formAsString      +=  elementAsString;
             formAsString      +=  fpFieldDelimiter;    
         }
         
         // append form serialization to the page serialization
         pageAsString += formAsString;
         pageAsString += fpFormDelimiter;
    }
    
    
    // add the focused element
    if(fpFocusedElementName){
      if(fpFocusedElementFormName){
         pageAsString+=fpCursorDelimiter;
         pageAsString+=fpFocusedElementFormName;
         pageAsString+=fpFieldDelimiter;
         pageAsString+=fpFocusedElementName;
      }
    }
    
    // add the submimitg form name
    if(fpSubmitFormName){
        pageAsString+=fpSubmitFormDelimiter;
        pageAsString+=fpSubmitFormName;
    }
    
    return pageAsString;
}//End of fpSerializePage

// deserialize a page and update the DOM 
function fpDeSerializePage(fpPageAsString){

  if(fpPageAsString===null){
    return;
  }
  
  var persistedArray      = fpPageAsString.split(fpCursorDelimiter);
  if(persistedArray.length<=0){
      return; // no data persisted  
  }
  
  var formsAsStringArray = persistedArray[0].split(fpFormDelimiter);//fpPageAsString.split(fpFormDelimiter); 
  
  // iterate through all the serialized forms
  for(  var f=0 ; f < formsAsStringArray.length ; f++ ){
  
        fromAsStringArray = formsAsStringArray[f].split(fpFieldDelimiter);
        
        formUniqueName = fromAsStringArray[0];
        
        form = fpGetFormElement(formUniqueName);
        if(!form){
            continue;
        }

        
        //iterate throught all the serialized fields
        for(var e=1;e<fromAsStringArray.length;e++){
            
            var elementAsStringArray = fromAsStringArray[e].split(fpInFieldDelimiter);
            
            var elementName   = fpUnescape(unescape(elementAsStringArray[0]));;
            var elementValue  = fpUnescape(unescape(elementAsStringArray[1]));
            
            // find the element into the current form
            var element =  form.elements[elementName];
            if(!element){
              continue;// can not gind such element
            }
            
            // for checkboxes and radio buttons
            if(!element.type){
              //NodeList
               for(var i=0;i<element.length;i++){
                  if(element[i].id){
                        
                        elementId = fpUnescape(unescape(elementAsStringArray[1]));
                        if(element[i].id==elementId){
                            element=element[i];
                            break;
                        }
                  }else{
                      elementValue = fpUnescape(unescape(elementAsStringArray[2]));
                      if(element[i].value==elementValue){
                          element=element[i];
                          break;
                      }
                  }
               }
            }
            
           
            if(!element.type){
               continue;// can not find the element inside the NodeList
            }
            
            var elementType = element.type;
            
            
             if( (elementType=="checkbox") || (elementType=="radio")){ 
                if(element.id){
                    
                    if(element.id != fpUnescape(unescape(elementAsStringArray[1]))){
                        continue;
                    }
                }
               
                var isChecked = elementAsStringArray[3];
                isChecked = (isChecked=='true') ? true : false;
                element.checked=isChecked;
                  
             } else if ( (elementType=="select-one") ){
             
                  element.selectedIndex = elementValue;
                 
             } else if ( (elementType=="select-multiple") ){
             
                  for(var o=1; o < elementAsStringArray.length;o++){
                    var selectedIndex = elementAsStringArray[o];
                    element.options[selectedIndex].selected = true;
                  }
             } else{ 
               element.value=elementValue;
             }
            
        }
        
   }
   
   // set the cursor position
   
   //check if there is already portlet anchoring on, in this case we don;t want to override portletanchoring by cursor foucs
   try {
   	if(iscPrltAnchorActive) {
   	    return;   // skip cursor focus
   	}
   } catch(err) { 
   	//catch error if variable is not found. 
   }
   
   // check if the cursor position is persisted   
   if(persistedArray.length<=1){
      return;   // no cursor persisted
   }
  
   var cursorArray          = persistedArray[1].split(fpFieldDelimiter);
   var cursorFormName       = cursorArray[0];
   var cursorElementName    = cursorArray[1];
   
   cursorForm = fpGetFormElement(cursorFormName);
   if(!cursorForm){
    return ; // no such form 
   }
   
   
   
   var focusedElement      =  cursorForm.elements[cursorElementName];
   if(!focusedElement){
      return; // no such element
   }
   
  
   if(!focusedElement.type){
         //NodeList
         focusedElement=focusedElement[0];
   }
   
   if(!focusedElement){
           return;// can not find the element inside the NodeList
   }
  
    try{
    // set the focus
     focusedElement.focus();
   }catch(err){
        //do nothing - remain the element unfocused
   }

}//End of fpDeSerializePage

function fpConstructFormName(element){

         formName= element.name;
         portletUniqueId = "";		 
		 hasParent = true;
		 while (hasParent) {
			eid = element.id;
			eidarr = eid.split(fpPortletIdDelimiter);
			if (eidarr[0] == fpPortletIdPrefix){
				portletUniqueId = fpPortletIdPrefix + fpPortletIdDelimiter +eidarr[1]+fpPortletIdDelimiter+eidarr[2];				
				hasParent = false;
			}
			element = element.parentNode;
			if (element === null) {
				hasParent = false;
			}
		 }

		 formName  +=  fpPortletIdDelimiter + portletUniqueId; 
         return formName;
}

function fpGetFormElement(formUniqueName){

        formUniqueNameArr = formUniqueName.split(fpPortletIdDelimiter);
		portletId = formUniqueNameArr[1]+fpPortletIdDelimiter+formUniqueNameArr[2]+fpPortletIdDelimiter+formUniqueNameArr[3];
        found = false;
		form  = null;
		for( var i=0 ; i < document.forms.length ; i++ ){			
			element = document.forms[i];
			hasParent = true;
			if (found) {
				continue;
			}
			while (hasParent) {
				element = element.parentNode;
				if (element === null) {
					hasParent = false;
				} else {
					if (element.id == portletId) {
                        if(document.forms[i].name==formUniqueNameArr[0]){
                            form = document.forms[i];
                            found = true; 
                            hasParent = false;	
                            break;                            
                        }
					}
				}
			}
			
		} 
        
        form = (!found) ? false : form;
        return form;
		
}


// Form Persistence callbacks

function fpPreSerialize(){// is invoked before the page is serialized
    return true;
}
function fpPostSerialize(){// is invoked after the page is serialized
}
function fpPreDeserialize(){// is invoked before the page is deserialized 
    return true;
}
function fpPostDeserialize(){// is invoked after the page is deserialized 
}
function fpPreFetch(){// is invoked before getCache Ajax request is made 
    return true;
}
function fpPostFetch(){// is invoked after getCache Ajax response is received 
}
function fpPreSave(){// is invoked before putCache Ajax request is made 
    return true;
}
// End of Form Persistence callbacks

// End of Form Persistence functions 
